#include "Appevent.ch"
#include "Common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "Font.ch"
#include "Directry.ch"

#define  aPRES_PARAM     { ;       // Presentation Parameter fuer den Browser
         {XBP_PP_COL_DA_FGCLR          , XBPSYSCLR_WINDOWSTATICTEXT   }, ;
         {XBP_PP_COL_DA_BGCLR          , XBPSYSCLR_WINDOW             }, ;
         {XBP_PP_COL_DA_HILITE_FGCLR   , XBPSYSCLR_HILITEFOREGROUND   }, ;
         {XBP_PP_COL_DA_HILITE_BGCLR   , XBPSYSCLR_HILITEBACKGROUND   }, ;
         {XBP_PP_COL_DA_COMPOUNDNAME   , FONT_DEFPROP_SMALL           }, ;
         {XBP_PP_COL_DA_ROWHEIGHT      , 32                           }, ;
         {XBP_PP_COL_DA_ROWWIDTH       , 8                            }, ;
         {XBP_PP_COL_DA_FRAMELAYOUT    , XBPFRAME_NONE                }, ;
         {XBP_PP_COL_DA_CELLFRAMELAYOUT, XBPFRAME_BOX                 }, ;
         {XBP_PP_COL_DA_CELLHEIGHT     , 32                           }, ;
         {XBP_PP_COL_DA_CELLWIDTH      , 8                            }}

#pragma Library( "XppUi2.lib" )

MEMVAR aTimeLine , np

PROCEDURE AppSys
RETURN

PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oBrowse
LOCAL oCol, i
LOCAL bBlock
LOCAL oDlg
LOCAL aPos  := {50,100}
LOCAL aSize := {808,226}

PRIVATE np  := 1            // index pointer into array
PRIVATE aTimeLine := LeerArray()

   oDlg          := XbpDialog():new( ,,aPos, aSize,, .F. )
   oDlg:icon     :=  1
   oDlg:taskList := .T.
   oDlg:title    := "DevCon 2007"
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( FONT_DEFPROP_SMALL )
   oDlg:drawingArea:resize := {|mp1,mp2,obj| obj:childList()[1]:setSize(mp2) }

   oBrowse := XbpBrowse():new( oDlg:drawingArea,,,, aPRES_PARAM )
   oBrowse:hScroll   := .F.
   oBrowse:vScroll   := .F.
   oBrowse:sizeCols  := .F.
   oBrowse:cursorMode:= XBPBRW_CURSOR_CELL
   oBrowse:create()

   oBrowse:skipBlock     := {|nSkip| -np + (np := MAX(1, MIN(LEN(aTimeLine), np + nSkip))) }
   oBrowse:goTopBlock    := {|| np := 1}
   oBrowse:goBottomBlock := {|| np := LEN(aTimeLine) }
   oBrowse:posBlock      := {|| np }
   oBrowse:phyPosBlock   := {|| np }
   oBrowse:lastPosBlock  := {|| Len( aTimeLine ) }
   oBrowse:firstPosBlock := {|| 1  }

   FOR i:=1 TO 100
      oCol       := XbpColumn():new(,,,,aPRES_PARAM)
      bBlock := "{|xVal| IF(xVal == NIL, aTimeLine[np][" +STR(i,3)+ "], aTimeLine[np][" +STR(i,3)+ "] := xVal) }"
      oCol:dataLink := &bBlock
      oCol:colorBlock := {|xVal| IF(xVal == "1",{GRA_CLR_WHITE,GraMakeRGBColor({000,100,204}) } ,;
                                 IF(xVal == "2",{GRA_CLR_WHITE,GraMakeRGBColor({025,138,255}) } ,;
                                 IF(xVal == "3",{GRA_CLR_WHITE,GraMakeRGBColor({076,164,254}) } ,;
                                 IF(xVal == "4",{GRA_CLR_WHITE,GraMakeRGBColor({153,203,255}) } ,;
                                 IF(xVal == "5",{GRA_CLR_BLACK,GraMakeRGBColor({229,242,255}) } ,;
                                                {GRA_CLR_BLACK,GRA_CLR_WHITE} ) ))) ) }
      oCol:create()
      oBrowse:addColumn( oCol )
   NEXT
   oBrowse:itemSelected := {|x,y,obj| Showme(obj:RowPos,obj:ColPos) }

   oDlg:show()
   oBrowse:show()

   TESTMARK(aTimeLine,oBrowse)

   SetAppFocus( oBrowse )
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      IF nEvent == xbeP_Keyboard .AND. mp1 = xbeK_ESC
         QUIT
      ENDIF
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
RETURN

FUNCTION LeerArray()
LOCAL aTimeline[5][100]
LOCAL i

      FOR i = 1 TO 5
          AFILL(aTimeline[i]," ")
      NEXT

RETURN aTimeline

FUNCTION Showme(nRow,nCol)
LOCAL a := LTRIM(STR(nRow))
LOCAL b := LTRIM(STR(nCol))
   MSGBOX("Reihe "+a+" Spalte "+b )
RETURN NIL

FUNCTION MARKFELD(aTimeline,aMark,nUser)
LOCAL nLen := LEN(aMark)
LOCAL i,xVal, zz

      FOR i = 1 TO nLen
          xVal := aMark[i]
          aTimeline[nUser,xVal] := STR(nUser,1)
      NEXT

RETURN NIL

PROCEDURE TESTMARK(aTimeline,oBrowse)
LOCAL aTOM := { {10,20},{30,55},{70,80},{99,100} }
LOCAL aJIM := { { 1, 8},{ 9,15},{17,28},{37,43},{47,58},{67,78},{81,88},{91,98} }
LOCAL aMAR := { {10,18},{27,48},{61,78},{87,98} }
LOCAL aHUB := { {10,19},{21,28},{31,48},{51,68},{81,88},{99,100} }
LOCAL aJAN := { {11,17},{25,32},{42,58},{67,88},{91,100} }
LOCAL aTXT
LOCAL i,iMax,j
LOCAL k,nLen
LOCAL aALL := {}

   AADD(aALL,aTOM)
   AADD(aALL,aJIM)
   AADD(aALL,aMAR)
   AADD(aALL,aHUB)
   AADD(aALL,aJAN)

   i := j := k := 1
   nLen := LEN(aALL)
   FOR k = 1 TO nLen
      aTXT := {}
      i := 1
      iMax := LEN(aALL[k])
      FOR i = 1 TO iMax
         j := 1
         FOR j = aALL[k][i][1] TO aALL[k][i][2]
            AADD(aTXT,j)
         NEXT j
      NEXT i
      MARKFELD(aTimeline,aTXT,k)
   NEXT k

   oBrowse:refreshall()

RETURN

*
*
*